/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
/**
 * JSON.parse Propagation Provider module.
 * @module lib/assess/propagators/JSON.parse.js
 */
'use strict';

const tracker = require('../../../tracker');
const patcher = require('../../../hooks/patcher');
const { PATCH_TYPES } = require('../../../constants');
const DeserializationMembrane = require('../../membrane/deserialization-membrane');

const ContrastJSON = require('../../../core/rewrite/injections').get('JSON');

/**
 * Handles propagation for when JSON.parse is invoked with
 * a tracked string as a parameter.
 *
 * @param {JSON}  __          - JSON module
 * @param {*}     parseResult - The return value of JSON.parse
 * @param {Array} parseArgs   - Arguments passed into JSON.parse:
 *                              text [,reviver]
 */
module.exports.handle = function() {
  ContrastJSON.enable();

  patcher.patch(ContrastJSON.value, 'parse', {
    name: ContrastJSON.name,
    patchType: PATCH_TYPES.ASSESS_PROPAGATOR,
    post(data) {
      const props = tracker.getData(data.args[0]);
      const { result } = data;
      if (props && result) {
        const membrane = new DeserializationMembrane(data, props);
        const wrapped = membrane.wrap(result);
        data.result = wrapped;
      }
    }
  });
};
